package demo

import "fmt"

type Doer interface {
	Do()
	EndDo()
}

type MyStruct struct {
	D Doer
}

type DoPrint struct{}

func (d DoPrint) Do() {
	fmt.Println("Doing")
}

func (d DoPrint) EndDo() {
	fmt.Println("End Doing")
}

func (s *MyStruct) Run() {
	s.D.Do()
	// defer s.D.EndDo()
}
